# Define the file path as a variable
$filePath = 'C:\Program Files (x86)\BenchMate 12\apps\CINEBENCH R15 EXTREME\15.0.3.8\CINEBENCH Windows 64 Bit.exe'

$counter = 0
$processName = "CINEBENCH Windows 64 Bit"
$startTime = Get-Date
$lastRunTime = $startTime

# Load the user32.dll to use the ShowWindowAsync function
Add-Type @"
using System;
using System.Runtime.InteropServices;
public class User32 {
[DllImport("user32.dll")]
public static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);
}
"@

while ($true) {
    $currentTime = Get-Date
    $elapsedTime = ($currentTime - $startTime).TotalSeconds
    $timeSinceLastRun = ($currentTime - $lastRunTime).TotalSeconds

    if (-not (Get-Process -Name $processName -ErrorAction SilentlyContinue)) {
        Start-Process -FilePath $filePath -ArgumentList '-cb_cpux' -WindowStyle Minimized
        $counter++
        $lastRunTime = Get-Date
        Write-Host "Application launched $counter times."
        
        # Convert time since last run to hh:mm:ss
        $timeSinceLastRunSpan = [timespan]::FromSeconds($timeSinceLastRun)
        $timeSinceLastRunFormatted = "{0:hh\:mm\:ss}" -f $timeSinceLastRunSpan
        Write-Host "Time since last run: $timeSinceLastRunFormatted"

        # Convert total elapsed time to hh:mm:ss
        $elapsedTimeSpan = [timespan]::FromSeconds($elapsedTime)
        $elapsedTimeFormatted = "{0:hh\:mm\:ss}" -f $elapsedTimeSpan
        Write-Host "Total elapsed time: $elapsedTimeFormatted"
    } else {
        # Get the handle of the main window
        $process = Get-Process -Name $processName -ErrorAction SilentlyContinue
        if ($process -and $process.MainWindowHandle -ne [IntPtr]::Zero) {
            # Minimize the window if it is not already minimized
            [User32]::ShowWindowAsync($process.MainWindowHandle, 2) | Out-Null
        }
    }

    Start-Sleep -Seconds 1
}